# path rewriting


## private parameters

Flagged in dartrix.yaml:

private: true

Parameters so marked are passed to Dartrix but not exposed as
user-settable parameters in the UI.  They set map entries in the
template data map.

Use case: identity transform.  Path segments in uppercase are subject
to path rewriting. If you want to preserve such a segment on output, make it a private parameter whose default value is the same.  For example:

in <template>/.yaml:

```
- name: 'myseg'
  private: true
  docstring: 'My segment.'
  typeHelp: 'segmented.string'
  defaultsTo: 'MYSEG
  seg: 'MYSEG'
```

Then if your path looks like `foo/MYSEG/bar`, the output will be the
result of the identity transform.
