# terminology

There are three directories associated with each package.  Normally
these are all the same, but the Dartrix package and plugins are
special cases.

* pkgHome
* pkgRunDir
* pkgConfig

* Package Configuration - either a `.dart_tool/package_config.json`
  (version 2) or a `.packages` (version 1) file.  Somewhat of a
  misnomer - those files just contain a list of dependencies, so
  "package dependency list" is more accurate.

* pkgHome - the root directory of the package structure.  Usually
  contains the pubspec.yaml and the package config, but not
  always. For example, packages installed with pub global have a
  pkgHome in `~/.pub-cache/hosted`, but their executables are
  installed in `~/.pub-cache/bin`.
* pkgRunDir - usually same as pkgHome, but not for pkgs installed globally.

* pkgConfigDir - the directory containing the package config used to
  configure Dartrix.  Dartrix has one (~/.dart.d) and so does each
  plugin. In the case of Dartrix, the pkgConfigDir is diffent that
  both the pkgHome dir and the pkgRunDir - three are different. For
  plugins, all three are the same dir.

Normally a package's Package Config lists dependencies the package
needs at runtime.  

Env vars:

* DARTRIX_HOME default: ~/.dart.d
