import 'dart:async';
import 'dart:convert';
import 'dart:io';
import 'dart:isolate';

import 'package:timeago/timeago.dart';

import 'package:args/args.dart';
import 'package:logging/logging.dart';

import 'src/frob.dart';
import 'src/tweak.dart';
import 'src/twiddle.dart';

var _log = Logger('dartrix');

SendPort dartrixPort;

String _resolvePkg(String pkg) {

}

void printUsage() {
  print("\n\t\tDartrix Template package: hello_templates\n");
  print("Available templates:\n");
  print("\thello");
  print("\tgoodbye\n");
  print("Pass -h to see template doc, e.g. -t hello -h\n");
}

void main(List<String> args, SendPort sport) {
  print("entry: hello_template/dartrix.dart main");
  final fifteenAgo = new DateTime.now().subtract(new Duration(minutes: 15));

  Logger.root.level = Level.ALL;
  Logger.root..onRecord.listen((record) {
      print('${record.loggerName} ${record.level.name}: ${record.message}');
      // ${record.time}:
  });
  // _log.info("entry: hello_template/dartrix.dart:main");
  dartrixPort = sport;

  // _log.info("args: $args");
  // First arg is the template name.
  // _log.info("template: ${args[0]}");

  switch(args[0]) {
    case "frob": generateFrob(args, sport); break;
    case "tweak": generateTweak(args, sport); break;
    case "twiddle": generateTwiddle(args, sport); break;
    case null:
    if (args.contains("--help") || args.contains("-h")) {
      printUsage();
    } else {
      print("frob_dartrix: No template specified; canceling.");
    }
    break;
    default:
    print("No template for ${args[0]}; canceling.");
    //TODO: send error to datrix isolate
  }
  // _log.info("exiting main...");
}
