import 'dart:io';
import 'dart:isolate';

import 'package:args/args.dart';
import 'package:logging/logging.dart';

var _log = Logger('frob');

void generateFrob(List<String> args, SendPort dartrixPort) {
  _log.info('generateFrob');

  var argParser = ArgParser();
  argParser.addOption('msg', abbr: 'm',
    valueHelp: 'String',
    help: 'Frobnication msg',
    defaultsTo: 'Frobbing',
  );
  argParser.addFlag('help', abbr: 'h', defaultsTo: false);
  argParser.addFlag('verbose', abbr: 'v', defaultsTo: false);
  argParser.addFlag('debug', defaultsTo: false);

  ArgResults options = argParser.parse(args);

  if (options['help']) {
    print('\npackage:frob_dartrix, template: frob\n');
    print('Arguments:\n');
    print(argParser.usage);
    exit(0);
  }

  var mydata = {
    'description' : {'frob' : 'frobnicate'},
    'msg': options['msg'],
    'dartrix': {'mergeData': true}
  };
  dartrixPort.send(mydata);
}
